/**
 * EPL eSync Pro(visioning): policy
 *
 * @link www.egroupware.org
 * @author Hadi Nategh <hn(at)egroupware.org>
 * @copyright (c) 2012 by Ralf Becker <rb(at)egroupware.org>
 * @package esyncpro
 * @subpackage policy
 * @version $Id$
 */

/**
 * UI for esyncpro
 *
 * @augments AppJS
 */
app.classes.esyncpro = AppJS.extend(
{
	appname: 'esyncpro',
	/**
	 * et2 widget container
	 */
	et2: null,
	/**
	 * path widget
	 */

	/**
	 * Constructor
	 *
	 * @memberOf app.esyncpro
	 */
	init: function()
	{
		// call parent
		this._super.apply(this, arguments);
	},

	/**
	 * Destructor
	 */
	destroy: function()
	{
		// call parent
		this._super.apply(this, arguments);
	},

	/**
	 * This function is called when the etemplate2 object is loaded
	 * and ready.  If you must store a reference to the et2 object,
	 * make sure to clean it up in destroy().
	 *
	 * @param et2 etemplate2 Newly ready object
	 */
	et2_ready: function(et2)
	{
		// call parent
		this._super.apply(this, arguments);

	},

	/**
	 * Disable/enable input elements in following tr's
	 */
	toggle_pw_required:function(pw_required)
	{
		if (typeof pw_required == 'undefined') pw_required = document.getElementById('exec[policy_pw_required]');

		//alert('pw_required='+(pw_required.checked ? 'true' : 'false'));

		var next_trs = jQuery(pw_required).closest('tr').nextAll();

		if (pw_required.checked)
		{
			next_trs.removeClass('securityDisabled');
			next_trs.find('input,select').prop('disabled',false);
		}
		else
		{
			next_trs.addClass('securityDisabled');
			next_trs.find('input,select').prop('disabled','disabled');
		}
	},
});