<?php
/**
 * eGroupWare - Setup
 * http://www.egroupware.org
 * Created by eTemplates DB-Tools written by ralfbecker@outdoor-training.de
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package esyncpro
 * @subpackage setup
 */

function esyncpro_upgrade0_2()
{
	$GLOBALS['egw_setup']->oProc->AddColumn('egw_esync_policies','policy_allow_popimap',array(
		'type' => 'bool',
		'default' => '1',
		'comment' => 'AllowPOPIMAPEmail: optinal'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('egw_esync_policies','policy_allow_browser',array(
		'type' => 'bool',
		'default' => '1',
		'comment' => 'AllowBrowser: optional'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('egw_esync_policies','policy_allow_consumer_email',array(
		'type' => 'bool',
		'default' => '1',
		'comment' => 'AllowConsumerEmail: optional'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('egw_esync_policies','policy_allow_rdesktop',array(
		'type' => 'bool',
		'default' => '1',
		'comment' => 'AllowRemoteDesktop: optional'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('egw_esync_policies','policy_allow_desktop_sync',array(
		'type' => 'bool',
		'default' => '1',
		'comment' => 'AllowDesktopSync: optinal'
	));

	return $GLOBALS['setup_info']['esyncpro']['currentver'] = '0.3';
}


function esyncpro_upgrade0_3()
{
	$GLOBALS['egw_setup']->oProc->RenameColumn('egw_esync_devices','dev_policy_updated','dev_policy_applied');

	$GLOBALS['egw_setup']->oProc->AddColumn('egw_esync_devices','dev_rw_status',array(
		'type' => 'int',
		'precision' => '1',
		'default' => '1',
		'comment' => '1=OK, 2=wipe pending, 3=wiped'
	));
	$GLOBALS['egw_setup']->oProc->AddColumn('egw_esync_devices','dev_wiped',array(
		'type' => 'timestamp',
		'comment' => 'TS when dev was wiped'
	));

	return $GLOBALS['setup_info']['esyncpro']['currentver'] = '0.4';
}


function esyncpro_upgrade0_4()
{
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_required',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '',
		'comment' => 'DevicePasswordEnabled: optinal, pw is required'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_simple',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowSimpleDevicePassword: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_alphanum',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '',
		'comment' => 'AlphanumericDevicePasswordRequired: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_complexity',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '3',
		'comment' => 'MinDevicePasswordComplexCharacters: 1-4: lower, upper case, numbers or non-alphanum chars required'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_dev_encryption',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '',
		'comment' => 'RequireDeviceEncryption: optional, device encryption required'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_card_encryption',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '',
		'comment' => 'RequireStorageCardEncryption: optional, storage card encryption required'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_length',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '1',
		'comment' => 'MinDevicePasswordLength: optional: 1-16'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_max_failed',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '5',
		'comment' => 'MaxDevicePasswordFailedAttempts: optional, 4-16'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_max_inactive_lock',array(
		'type' => 'int',
		'precision' => '2',
		'nullable' => False,
		'default' => '166',
		'comment' => 'MaxInactivityTimeDeviceLock: optional, in secs, db in min'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_recovery',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'PasswordRecoveryEnabled: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_expiration',array(
		'type' => 'int',
		'precision' => '1',
		'comment' => 'DevicePasswordExpiration: optional, in days'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_pw_history',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '0',
		'comment' => 'DevicePasswordHistory: optional, 0=not required'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_max_cal_age',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '7',
		'comment' => 'MaxCalendarAgeFilter: optional, 0=all, 4=2weeks, 5=1month, 6=3month, 7=6month'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_max_email_age',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '5',
		'comment' => 'MaxEmailAgeFilter: optinal, 0=all, 1=1day, 2=3days, 3=1week, 4=2weeks, 5=1month'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_max_email_size',array(
		'type' => 'int',
		'precision' => '4',
		'nullable' => False,
		'default' => '-1',
		'comment' => 'MaxEmail(HTML)BodyTruncationSize, optional, -1=no truncation, 0=header only, >0=size in byte, db in kb'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_roaming_manual',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '',
		'comment' => 'RequireManualSyncWhenRoaming: optinal'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_html',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_attachments',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AttachmentsEnabled: optinal'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_sms',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowTextMessaging: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_card',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowStorageCard: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_camera',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowCamera: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_wifi',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowWifi: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_irda',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowIrDA: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_inetsharing',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowInternetSharing: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_bluetooth',array(
		'type' => 'int',
		'precision' => '1',
		'nullable' => False,
		'default' => '2',
		'comment' => 'AllowBluetooth: 0=no, 1=no, but handsfree, 2=yes'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_popimap',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowPOPIMAPEmail: optinal'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_browser',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowBrowser: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_consumer_email',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowConsumerEmail: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_rdesktop',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowRemoteDesktop: optional'
	));
	$GLOBALS['egw_setup']->oProc->AlterColumn('egw_esync_policies','policy_allow_desktop_sync',array(
		'type' => 'bool',
		'nullable' => False,
		'default' => '1',
		'comment' => 'AllowDesktopSync: optinal'
	));

	return $GLOBALS['setup_info']['esyncpro']['currentver'] = '0.5';
}


function esyncpro_upgrade0_5()
{
	$GLOBALS['egw_setup']->oProc->DropColumn('egw_esync_devices',array(
		'fd' => array(
			'dev_id' => array('type' => 'auto','nullable' => False),
			'account_id' => array('type' => 'int','precision' => '4'),
			'dev_name' => array('type' => 'varchar','precision' => '64'),
			'dev_model' => array('type' => 'varchar','precision' => '64'),
			'dev_phoneno' => array('type' => 'varchar','precision' => '64'),
			'dev_operator' => array('type' => 'varchar','precision' => '64'),
			'dev_type' => array('type' => 'varchar','precision' => '64'),
			'dev_uid' => array('type' => 'varchar','precision' => '64','nullable' => False),
			'dev_imei' => array('type' => 'varchar','precision' => '15'),
			'dev_os' => array('type' => 'varchar','precision' => '64'),
			'dev_lang' => array('type' => 'varchar','precision' => '32'),
			'dev_useragent' => array('type' => 'varchar','precision' => '64'),
			'dev_access_status' => array('type' => 'bool'),
			'dev_access_via' => array('type' => 'int','precision' => '1'),
			'policy_id' => array('type' => 'int','precision' => '4'),
			'dev_policy_applied' => array('type' => 'timestamp','comment' => 'TS when policy was applied'),
			'dev_as_version' => array('type' => 'varchar','precision' => '8'),
			'dev_last_sync' => array('type' => 'timestamp'),
			'dev_modified' => array('type' => 'timestamp','nullable' => False,'default' => 'current_timestamp'),
			'dev_modifier' => array('type' => 'int','precision' => '4'),
			'dev_rw_status' => array('type' => 'int','precision' => '1','default' => '1','comment' => '1=OK, 2=wipe pending, 3=wiped'),
			'dev_wiped' => array('type' => 'timestamp','comment' => 'TS when dev was wiped')
		),
		'pk' => array('dev_id'),
		'fk' => array(),
		'ix' => array('account_id','dev_imei'),
		'uc' => array('dev_id','dev_uid')
	),'dev_status');
	$GLOBALS['egw_setup']->oProc->AddColumn('egw_esync_devices','dev_last_cmd',array(
		'type' => 'varchar',
		'precision' => '32',
		'comment' => 'last AS command'
	));

	return $GLOBALS['setup_info']['esyncpro']['currentver'] = '0.6';
}


function esyncpro_upgrade0_6()
{
	return $GLOBALS['setup_info']['esyncpro']['currentver'] = '14.1';
}


function esyncpro_upgrade14_1()
{
	return $GLOBALS['setup_info']['esyncpro']['currentver'] = '16.1';
}

function esyncpro_upgrade16_1()
{
	return $GLOBALS['setup_info']['esyncpro']['currentver'] = '17.1';
}
